Gauge with Ticks in JavaScript

Using ApexCharts with JavaScript

This Gauge with Ticks example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [64],
  chart: {
    height: 360,
    type: 'gauge',
  },
  plotOptions: {
    radialBar: {
      startAngle: -135,
      endAngle: 135,
      ticks: {
        show: true,
        major: {
          count: 11,
          length: 12,
          width: 2,
          color: '#475569',
          placement: 'outside',
        },
        minor: {
          count: 3,
          length: 6,
          width: 1,
          color: '#94A3B8',
          placement: 'outside',
        },
        labels: {
          show: true,
          offset: 8,
          fontSize: '11px',
          color: '#475569',
          formatter: function (v) {
            return Math.round(v)
          },
        },
      },
      hollow: {
        margin: 30,
        size: '50%',
      },
      track: {
        strokeWidth: '60%',
        background: '#E2E8F0',
      },
      dataLabels: {
        name: { show: false },
        value: {
          offsetY: 8,
          fontSize: '28px',
          fontWeight: 600,
          formatter: function (val) {
            return val + '%'
          },
        },
      },
    },
  },
  labels: ['Progress'],
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Gauge with Ticks in Angular

Using ApexCharts with Angular

This Gauge with Ticks example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [64],
          chart: {
            height: 360,
            type: 'gauge',
          },
          plotOptions: {
            radialBar: {
              startAngle: -135,
              endAngle: 135,
              ticks: {
                show: true,
                major: {
                  count: 11,
                  length: 12,
                  width: 2,
                  color: '#475569',
                  placement: 'outside',
                },
                minor: {
                  count: 3,
                  length: 6,
                  width: 1,
                  color: '#94A3B8',
                  placement: 'outside',
                },
                labels: {
                  show: true,
                  offset: 8,
                  fontSize: '11px',
                  color: '#475569',
                  formatter: (v) => {
                    return Math.round(v)
                  },
                },
              },
              hollow: {
                margin: 30,
                size: '50%',
              },
              track: {
                strokeWidth: '60%',
                background: '#E2E8F0',
              },
              dataLabels: {
                name: { show: false },
                value: {
                  offsetY: 8,
                  fontSize: '28px',
                  fontWeight: 600,
                  formatter: (val) => {
                    return val + '%'
                  },
                },
              },
            },
          },
          labels: ['Progress'],
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Gauge with Ticks in Vue

Using ApexCharts with Vue

This Gauge with Ticks example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="gauge"
        height="360"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [64],
      chartOptions: {
        chart: {
          height: 360,
          type: 'gauge',
        },
        plotOptions: {
          radialBar: {
            startAngle: -135,
            endAngle: 135,
            ticks: {
              show: true,
              major: {
                count: 11,
                length: 12,
                width: 2,
                color: '#475569',
                placement: 'outside',
              },
              minor: {
                count: 3,
                length: 6,
                width: 1,
                color: '#94A3B8',
                placement: 'outside',
              },
              labels: {
                show: true,
                offset: 8,
                fontSize: '11px',
                color: '#475569',
                formatter: function (v) {
                  return Math.round(v)
                },
              },
            },
            hollow: {
              margin: 30,
              size: '50%',
            },
            track: {
              strokeWidth: '60%',
              background: '#E2E8F0',
            },
            dataLabels: {
              name: { show: false },
              value: {
                offsetY: 8,
                fontSize: '28px',
                fontWeight: 600,
                formatter: function (val) {
                  return val + '%'
                },
              },
            },
          },
        },
        labels: ['Progress'],
      },
    }
  },
}
</script>

<style>
#chart {
  padding: 0;
  max-width: 420px;
  margin: 35px auto;
}
</style>

Gauge with Ticks in React

Using ApexCharts with React

This Gauge with Ticks example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [64],
    options: {
      chart: {
        height: 360,
        type: 'gauge',
      },
      plotOptions: {
        radialBar: {
          startAngle: -135,
          endAngle: 135,
          ticks: {
            show: true,
            major: {
              count: 11,
              length: 12,
              width: 2,
              color: '#475569',
              placement: 'outside',
            },
            minor: {
              count: 3,
              length: 6,
              width: 1,
              color: '#94A3B8',
              placement: 'outside',
            },
            labels: {
              show: true,
              offset: 8,
              fontSize: '11px',
              color: '#475569',
              formatter: function (v) {
                return Math.round(v)
              },
            },
          },
          hollow: {
            margin: 30,
            size: '50%',
          },
          track: {
            strokeWidth: '60%',
            background: '#E2E8F0',
          },
          dataLabels: {
            name: { show: false },
            value: {
              offsetY: 8,
              fontSize: '28px',
              fontWeight: 600,
              formatter: function (val) {
                return val + '%'
              },
            },
          },
        },
      },
      labels: ['Progress'],
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="gauge"
          height={360}
        />
      </div>
    </div>
  )
}

export default ApexChart